# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceBus::Mgmt::V2017_04_01
  module Models
    #
    # Single item in List or Get Migration Config operation
    #
    class MigrationConfigProperties < Resource

      include MsRestAzure

      # @return [String] Provisioning state of Migration Configuration
      attr_accessor :provisioning_state

      # @return [Integer] Number of entities pending to be replicated.
      attr_accessor :pending_replication_operations_count

      # @return [String] Existing premium Namespace ARM Id name which has no
      # entities, will be used for migration
      attr_accessor :target_namespace

      # @return [String] Name to access Standard Namespace after migration
      attr_accessor :post_migration_name

      # @return [String] State in which Standard to Premium Migration is,
      # possible values : Unknown, Reverting, Completing, Initiating, Syncing,
      # Active
      attr_accessor :migration_state


      #
      # Mapper for MigrationConfigProperties class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'MigrationConfigProperties',
          type: {
            name: 'Composite',
            class_name: 'MigrationConfigProperties',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              provisioning_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.provisioningState',
                type: {
                  name: 'String'
                }
              },
              pending_replication_operations_count: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.pendingReplicationOperationsCount',
                type: {
                  name: 'Number'
                }
              },
              target_namespace: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.targetNamespace',
                type: {
                  name: 'String'
                }
              },
              post_migration_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.postMigrationName',
                type: {
                  name: 'String'
                }
              },
              migration_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.migrationState',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
